// 2013.11.30, created by HF for ECC

#ifndef __ECCLIB__
#define __ECCLIB__

/* Data types */
#define BOOLTYPE   0
#define INTTYPE    1
#define DOUBLETYPE 2
#define CHARTYPE   3

/* Grade up or down */
/*#define GRADEUP     1 93/1/25 avoid poss name conflict */
/*#define GRADEDOWN  -1                                  */

/* Macros */
#ifndef max
#define max(A,B) (A>B? A : B)
#endif
#ifndef min
#define min(A,B) (A<B? A : B)
#endif        /*moved to Globals.h 98/7/25 */
#define imod(A,B) (A==0? B: (A>0&&B>0||A<0&&B<0)? (B%A):B%A==0? 0:A+B%A)
#define gmod(A,B) (A==0 ? B : B - A*floor(QDCT+((double) B)/(double) A))
#define sig(A) (A==0 ? 0 : A>0 ? 1: -1)

#define inchp0 if ((r15-=(r0+31)>>5<<2) <0) alloc(0) //***************
#define inchp1 if ((r15-=r0<<2) <0) alloc(1)
#define inchp2 r15-=r0<<3;r15>>=3;r15<<=3;if(r15<0) alloc(2)
#define inchp3 if ((r15-=(r0+3)>>2<<2) <0) alloc(3)  //*** 7/12 wc ***

/* Usefull constants */
#define msk    0x0000001f
#define alf    (unsigned) 0xffffffff
#define lfb    (unsigned) 0x80000000
/*#define lf1    0x80000000   92/12/7 out for EVL */
#define pi     3.141592653589793
#define maxi   2147483647
#define mini   -2147483647

#define DBLFMTBD  1.0e-5   /* if r<DBLFMTBD, we use %e format*/

/* Store format data representation */
typedef struct stofm2 {char *valp; int maxl,reall;} STOFM2;
typedef struct stofm3 {char *valp; int maxl,reall; int dims[7];} STOFM3;

typedef union {
   STOFM2 fm2;
   STOFM3 fm3;
   } DESCRIPT;

/* Functions */
void * amalloc(int size);
void * acalloc(int size, int chuck);
void alloc(int typ);
FILE *a_fopen(char *szFN, char *szMode);
int apl_sec();
char *a_fmtI(int *pData, int iQdpp, int npts);
void a_pack(char *pBuff, int iQdpp);
char *a_fmtD(double *pData, int iQdpp, int npts);
void a_prtD0(double v);
int no_of_ones(int r0, int * p0);
extern int n, v1, v2, r1, t;
void passparmb (FILE * fpl, int lgth, int * p0);
void prntbool (int * p0, int cl);
extern int fact[13];
int ifac(int n);
double efac(int n);
double ebin(int n,int m);
int randomn(int n);
void mat_inverse(double* a,double* y,int n);
void ludcmp(double *a,int n,int *indx,double *d);
void lubksb(double *a,int n,int *indx,double *b);
void boolcvi (int* targ,int* ooc,int llgth,int lgth);
void boolcvd (double* targ,int* ooc,int llgth,int lgth);
void boolcv1i(int* targ,int* ooc,int n,int i,int sl);
void boolcv1d(double* targ,int* ooc,int n,int i,int sl);
void bitsmove (int *targ,int* rrc,int r0,int n);
void bitsmovc (int* targ,int* rrc,int ll,int rrl,int i);
void bitsmov0 (int* targ,int* rrc,int ll,int rrl,int i);
void bitsmovs (int* targ,int rrc,int ll,int rrl,int i);
extern int qw, qi;
void  bitsmov1 (int* targ,int* rrc,int sw,int si,int lslg);
int  findfst0(int* llc,int lopl,int qdio);
int  findfst1(int* llc,int lopl,int qdio);
void boolidxof(int* ttc,int* llc,int* rrc,int lopl,int ropl,int qdio);
void bol1idxof(int* ttc,int llc,int* rrc,int ropl,int qdio);
void wrapmove(int* ttc,int* rrc,int r0,int ropl);
int count3b0(int tl,int j,int n);
int count32b(int t,int n);
void breductv(int *ttc,int * rrc,int  r0,int lplg0);
int  breduct0(int *rrc, int ropl);
void bscan0(int* ttc,int* rrc, int ropl);
void bscan20(int* ttc,int* pt,unsigned int * pwa,int  v1,int  segl, int i, int j);
void gscan20m(int* ttc,int* rrc,int r0,int n);
void gscan20v(int* ttc,int* rrc,int r0,int n);
void copybits1(int* ttc,int i,int j,int rlth);
void aplbit0(int* p0,int u0,int r0,int size,int* ro0);
void  aplbit1(int r0,int v3,int* ttc,int* rrc);
void  aplbit2(int r0,int v3,int* ttc,int* rrc);
void  aplbit3(int r0,int v3,int* ttc,int* rrc);
void all1s(int* ttc,int r0);
void reversi(int* ttc,int* rrc,int v3,int n0,int r1,int seg,int tl);
void reversm(double* ttc,int* rrc,int v3,int n0,int r1,int seg,int tl);
void reversd(double* ttc,double* rrc,int v3,int n0,int r1,int seg,int tl);
void reversc(char* ttc,char* rrc,int v3,int n0,int r1,int seg,int tl);
void areversi(int* ttc,int* rrc,int q0,int r1,int r2,int seg);
void areversm(double* ttc,int* rrc,int q0,int r1,int r2,int seg);
void areversd(double* ttc,double* rrc,int q0,int r1,int r2,int seg);
void areversc(char* ttc,char* rrc,int q0,int r1,int r2,int seg);
void breversi(int* ttc,int* rrc,int r0);
void breversm(double* ttc,int* rrc,int r0);
void breversd(double* ttc,double* rrc,int r0);
void breversc(char* ttc,char* rrc,int r0);
void rotatfxi(int* ttc,int* llc,int* rrc,int notb,int q1,int q2);
void rotatfxd(double* ttc,int* llc,double* rrc,int q1,int q2);
void rotatfxc(char* ttc,int* llc,char* rrc,int q1,int q2);
void rotatfxm(double* ttc, int* llc,int* rrc,int q1,int q2);
void takei(int* ttc,int* rrc,int r0,int rrl,int lopv);
void taked(double* ttc,double* rrc,int r0,int rrl,int lopv);
void takec(char* ttc,char* rrc,int r0,int rrl,int lopv);
void takem(double* ttc,int* rrc,int r0,int rrl,int lopv);
void tak2d(double* p2,int* v19,double* ro2,int ropd0,int ropd1,int s0,int s1,int* cad,int* tdl,int* dl);
void tak2i(int* p2,int* v19,int* ro2,int ropd0,int ropd1,int s0,int s1,int* cad,int* tdl,int* dl);
void tak2m(double* p2,int* v19,int* ro2,int ropd0,int ropd1,int s0,int s1,int* cad,int* tdl,int* dl);
void tak2c(char* p2,int* v19,char* ro2,int ropd0,int ropd1,int s0,int s1,int* cad,int* tdl,int* dl);
int membsp0b (int lop0,int* rrc,int ropl);
void membspc(int* ttc,char* llc,int lopl,char* rrc,int ropl);
void idxofc(int* ttc,char* llc,int lopl,char* rrc,int ropl,int qdio);
extern int dvz[20];
void * acalloc(int size, int chuck);
void membspi(int* ttc,int* llc,int lopl,int* rrc,int ropl);
void idxofi(int* ttc,int* llc,int lopl,int* rrc,int ropl,int qdio);
extern int dvs[20];
extern int sfr[20];
extern double Hflt;
void * amalloc(int size);
void * acalloc(int size, int chuck);
void membspd(int* ttc,double* llc,int lopl,double* rrc,int ropl);
void membspm(int* ttc,double* llc,int lopl, int* rrc,int ropl);
void membspn(int* ttc,int* llc,int lopl,double* rrc,int ropl);
void idxofd(int* ttc,double* llc,int lopl,double* rrc,int ropl,int qdio);
void idxofm(int* ttc,double* llc,int lopl,int* rrc,int ropl,int qdio);
void idxofn(int* ttc,int* llc,int lopl,double* rrc,int ropl,int qdio);
int compeqI(int* v,int* Indx,int qdio,int i,int j);
int compeqD(double* v,int* Indx,int qdio,int i,int j);
//int qcompIndx(int* i,int* j);
int qcompIndx(const void *i,const void *j);
int compupI(int* v, int i,int j,int size);
int compupD(double* v,int i,int j,int size);
int compupC(char* v,int i,int j,int size);
int compdnI(int* v,int i,int j,int size);
int compdnD(double* v,int i,int j,int size);
int compdnC(char* v,int i,int j,int size);
void swap(void* v,int* Indx,int i,int j,int size);
int TotalBytes(int iType,int n);
void sortI(int n,int* v,int* itemp);
void sortD(int n,double* v,int* itemp);
void a_grade(void* v,int iType,int* Indx,int qdio,int n,int option);

#endif
